library XT_Search;

uses Windows, XT_API;

var
	MainWnd: HWnd;

function XT_Init(nVersion, nFlags: DWord; hMainWnd: HWnd; lpReserved: Pointer): LongInt; stdcall; export;
begin
	if Assigned(XWF_OutputMessage) then begin
		Result:=1;
		MainWnd:=hMainWnd;
	end else
		Result:=-1;
end;

function XT_About(hTopWnd: HWnd; lpReserved: Pointer): LongInt; stdcall; export;
begin
	MessageBox(hTopWnd, 'This sample X-Tension provided by X-Ways runs a logical search and can filter out its own hits.', 'Search Demo', MB_ICONINFORMATION);
end;

var
	NoOfFilteredSearchHits, TotalNoOfSearchHits: LongInt;

function XT_ProcessSearchHit(HitInfo: PSearchHitInfo): DWord; stdcall; export;
begin
	Result:=0;

	{if ((HitInfo.nRelOfs>-1) and (HitInfo.nRelOfs mod 2=1))
	or ((HitInfo.nAbsOfs>-1) and (HitInfo.nAbsOfs mod 2=1)) then begin
		HitInfo.nFlags:=HitInfo.nFlags or $0008; // discard search hit
		Inc(NoOfFilteredSearchHits);
	end;

	Inc(TotalNoOfSearchHits);}
end;

function XT_PrepareSearch(PSInfo: PPrepareSearchInfo; CPages: PCodePages): LongInt; stdcall; export;
begin
	{Append on more search term.}
	lStrCatW(PSInfo.lpSearchTerms, AnsiChar($D));
	lStrCatW(PSInfo.lpSearchTerms, AnsiChar($A));
	lStrCatW(PSInfo.lpSearchTerms, 'One more search term');
	Result:=1;
end;

function XT_Finalize(hVolume, hEvidence: THandle; nOpType: DWord; lpReserved: Pointer): LongInt; stdcall; export;
{will be called after all other volume snapshot refinement operations}
var
	SInfo: TSearchInfo;
	CPages: TCodePages;
begin
	if (nOpType=XT_ACTION_RVS) or (nOpType=XT_ACTION_RUN) then begin
		NoOfFilteredSearchHits:=0;
		TotalNoOfSearchHits:=0;

		ZeroMemory(@SInfo, SizeOf(TSearchInfo));
		SInfo.nSize:=SizeOf(TSearchInfo);
		SInfo.hVolume:=hVolume;
		SInfo.lpSearchTerms:='Hel.o'+#13+#10+'Goodbye';
		SInfo.nFlags:=XWF_SEARCH_LOGICAL or XWF_SEARCH_OMITDIRS or XWF_SEARCH_CALLPSH or XWF_SEARCH_DISPLAYHITS or XWF_SEARCH_GREP;

		SInfo.pLatin1Alphabet:='abcdefghijklmnopqrstuvwxyz';
		SInfo.pNonLatin1Alphabet:='';

		ZeroMemory(@CPages, SizeOf(TCodePages));
		CPages.nSize:=SizeOf(TCodePages);
		CPages.nCodePage[0]:=1252;
		CPages.nCodePage[1]:=1200;

		XWF_Search(@SInfo, @CPages);
	end;

	Result:=0;
end;


exports
	XT_Init,
	XT_About,
	XT_ProcessSearchHit,
	XT_PrepareSearch,
	XT_Finalize;

begin
	{Here you could insert code that gets executed when the DLL is loaded.}

end.
